// program bound_estimation_specification1.prg (a version of ineq0_just_point_estimates for public distribution)
// March 3, 2010
// This program produces the baseline inequality estimates for the sample.  It produces the estimate of for Specification 1 (Basic Moments with 12 Inequalities)
//  specification 1 in Table XI

/* Structure */
/* 1. Set up */
/* 2. Estimation of bound parameters */


new;
cls;
library lpmt, optmum;
#include lpmt.sdf;
#include optmum.ext;

output file=d:\a_data\proj\wal_proj\public\bound_estimation_specification1.out reset;
outwidth 132;
"bound_estimation1.prg";
format /rd 10,5;
add_interactions=0;  //set at the top of the program
year_start=0; year_end=9999; //year_start=0 and year_end=9999 means all years are included in this sample;
num_draws=0; // the number of subsampling draws.  Need to be big enough so that the cholsky works.
num_sim=0;  


cutoff1_1=-750; cutoff1_2=-1500;
cutoff2_1=750; cutoff2_2=1500;

do_no_stage1_error_also=1;  // set =1 if want to run this with and without stage1 error.


if (year_start==0 and year_end==9999); yearcat="A"; 
elseif (year_start==1990 and year_end==9999); yearcat="B";
elseif (year_start==0 and year_end==1989); yearcat="C"; endif;


//Decleare the name of structures (Do not have to repeat);
struct LPout out0; 


// file 'd:\a_data\proj\wal_proj\deviation\dev_con_logit\pert_pv_complete.asc';
// put  type_tom_numeric ',' convert_cat ',' store1z ',' store2z ',' 
// put  1  type_tom_numeric 2 convert_cat 3 store1z 4 store2z ',' 
// 5  year_open1z 6 year_super1z 7 year_open2z 8 year_super2z 9  pert_id  
// 10  n1 11 n2  
// 12 d_opprof 13 d_dc_dist 14 d_lnneig5 15 d_lnneig5_2 16 weight_factor
// 17 d_opprof_gen 18 d_opprof_groc 19 d_dc_gen_dist 20 d_dc_groc_dist 
// 21 d_lnneig5_gen 22 d_lnneig5_groc 23 d_lnneig5_2_gen 24 d_lnneig5_2_groc
// load rawdat[350574,24]=d:\a_data\proj\wal_proj\deviation\dev_con_logit\pert_pv_revision.asc;
// save d:\a_data\proj\wal_proj\deviation\dev_con_logit\pert_pv_revision=rawdat;

//load rawdat[800353,24]=d:\a_data\proj\wal_proj\deviation\dev_con_logit\pert_pv_complete.asc;
//save d:\a_data\proj\wal_proj\deviation\dev_con_logit\pert_pv_complete=rawdat;


// Now load perturbation data.
load rawdat=d:\a_data\proj\wal_proj\public\dat2\pert_pv_complete;

type_tom=rawdat[.,1]; convert_cat=rawdat[.,2]; store1=rawdat[.,3]; store2=rawdat[.,4];
year_open1=rawdat[.,5]; year_super1=rawdat[.,6]; year_open2=rawdat[.,7]; year_super2=rawdat[.,8];  pert_id=rawdat[.,9];
n1=rawdat[.,10]; n2=rawdat[.,11];
d_dc_dist=rawdat[.,13];  weight_factor=rawdat[.,16];


dc_dist_breakdown=0;  //=0 if no breakdown, =1 if separate gen and food
if dc_dist_breakdown==0;
    x=rawdat[.,12 14 15 13];
    x[.,4]=.001.*x[.,4]; //rescale into 1000 of miles
    // order: d_opprof d_lnneig5 d_lnneig5_2 d_dc_dist
    numx=4;
elseif dc_dist_breakdown==1;
    x=rawdat[.,12 14 15 19 20];
    x[.,4 5]=.001.*x[.,4 5];
    // order: d_opprof d_lnneig5 d_lnneig5_2 d_dc_gen_dist d_dc_groc_dist
    numx=5;
endif;

clear rawdat;//Thorow away original data to save memory; 

// Initial Parameters;
print_x_mean=0;  // set =1 if print of x_mean is desired, otherwise =0;

"***********************************************************************************";
print "parameters of exercise";
"***********************************************************************************";
"year_star=" year_start "year_end=" year_end;
print "cutoff1_1" cutoff1_1 "cutoff1_2" cutoff1_2 "cutoff2_1" cutoff2_1 "cutoff2_2" cutoff2_2 ;
if add_interactions==0; "0 No interactions";
elseif add_interactions==1; "1 Includes interactions,  level 1"; 
elseif add_interactions==2; "2 INcludes intersactions, level 2"; 
elseif add_interactions==3; "3 INcludes intersactions, level 3";
elseif add_interactions==4; "4 INcludes intersactions, level 4";
elseif add_interactions==5; "5 INcludes intersactions, level 5";    
endif;
"";
"";
// Step 1: classify each observation into a group, group=0 means this will be not used;

group=zeros(rows(rawdat),1);

z_d_dc_dist=d_dc_dist.*weight_factor;    
cond1= (type_tom.==1).and(cutoff1_1.<=z_d_dc_dist).and(z_d_dc_dist.< 0);
cond2= (type_tom.==1).and(cutoff1_2.<=z_d_dc_dist).and(z_d_dc_dist.<cutoff1_1);
cond3= (type_tom.==1).and(z_d_dc_dist.<cutoff1_2);


cond4= (type_tom.==2).and(0 .<z_d_dc_dist).and(z_d_dc_dist.<=cutoff2_1);
cond5= (type_tom.==2).and(cutoff2_1.<z_d_dc_dist).and(z_d_dc_dist.<=cutoff2_2);
cond6= (type_tom.==2).and(cutoff2_2.<z_d_dc_dist);

cond7= ((type_tom.==31).or(type_tom.==32)).and (n1.>=100)                   .and  (n2.>=40)    .and (n2.<100);
cond8= ((type_tom.==31).or(type_tom.==32)).and (n1.>=40)   .and (n1.<100)   .and  (n2.>=15)    .and (n2.<40);
cond9= ((type_tom.==31).or(type_tom.==32)).and (n1.>=15)   .and (n1.<40)                       .and (n2.<15);
cond10= ((type_tom.==31).or(type_tom.==32))                 .and (n1.<15)    .and  (n2.>=15)    .and (n2.<40);
cond11= ((type_tom.==31).or(type_tom.==32)).and (n1.>=15)   .and (n1.<40)    .and  (n2.>=40)    .and (n2.<100);
cond12= ((type_tom.==31).or(type_tom.==32)).and (n1.>=40)   .and (n1.<100)   .and  (n2.>=100);

//Group ID;
group=(cond1.==1).*1 + (cond2.==1).*2 + (cond3.==1).*3 + (cond4.==1).*4
     +(cond5.==1).*5 + (cond6.==1).*6 + (cond7.==1).*7 + (cond8.==1).*8
     +(cond9.==1).*9 + (cond10.==1).*10 + (cond11.==1).*11 + (cond12.==1).*12;
numgroup=maxc(group);


"\n\n***********************************************************************************";
print "group frequency count";
"***********************************************************************************";
seqa(0,1,1+numgroup)~counts(group,seqa(0,1,1+numgroup));


// Selection;
//      year ;
year_select=((convert_cat.==1) .and (year_start.<=year_open1) .and (year_open1.<=year_end))
        .or ((convert_cat.==2) .and (year_start.<=year_super1).and (year_super1.<=year_end));

           
// Other selection;
// (for example, do here if want to select by convert_cat);
other_select=ones(rows(rawdat),1);  //for now not using this for anything

// Combine year_select and other_select;
full_select=year_select .and other_select .and (group .> 0);
group_select=selif(group,full_select);
x_select=selif(x,full_select);
weight_factor_select=selif(weight_factor,full_select);
store1_select=selif(store1,full_select);
store2_select=selif(store2,full_select);

// Construct Group Dummy;
num_perturb=rows(x_select);
group_dummy=zeros(num_perturb,numgroup);

i=1;
do while i<=numgroup;
    group_dummy[.,i]=group_select.==i;
    i=i+1; 
endo;



// Construct X_mean:=Z'y and Z'X things;
z=construct_z(x_select,weight_factor_select,add_interactions);
xz_mean=construct_xz_mean(x_select,group_select,z);


// convert to a and b notation
a_dat=xz_mean[.,4]~xz_mean[.,2]~(-xz_mean[.,3]);
b_dat=xz_mean[.,1];  



dim_w=rows(a_dat)*(cols(a_dat)+1);
w_dat=reshape(a_dat~b_dat,1,dim_w);
t0=hsec;


//***********************************************************************************************
// Estimation: Now linear program 
//***********************************************************************************************


a=a_dat; b=b_dat;
"";
print "Number of constraints=" rows(a);
print "Number of perturbations used=" rows(x_select);
"";
__output=0;
"start by seeing whether feasible";
theta_example=.003|4.3|.5;
{theta_star_tran,vof_optmum,g,retcode } = optmum(&obj,sqrt(theta_example));
theta_star=theta_star_tran.^2;
"vof (feasible if zero)=" vof_optmum;
print "theta_star (from optmum call minimizing Q=" theta_star';
"";
"";

"Now run new procedure that does both in one step";
"   (Note, can skip to the to bottom of the output to see the final results.  Will print intermediate output from the linear program)";
"";
"";
{min_value,theta_lower,lpmt_returncode,max_value,theta_upper,vof}=lpmt_tom(a_dat, b_dat, 1, 0);
"";
"";
"*************************************************************************";
"Now conclude by printing the results reported in the paper in Table XI, first line, Specification 1";
print "lower=" min_value "upper=" max_value;




//Now have programs for procedures.

//  Procedture to construct instruments;
proc (1)=construct_z(x_hold,weight_factor_hold,add_interactions);
local x_plus, x_minus, x_both,x_both2,x_both3,x_both4,x_both5, z_hold, numxboth, firstone, i1, i2, i3, i4, i5;
    if add_interactions>=1;
    x_plus=  ( x_hold[.,2:numx]-minc( x_hold[.,2:numx])')./(maxc( x_hold[.,2:numx])'-minc( x_hold[.,2:numx])');
    x_minus= (-x_hold[.,2:numx]-minc(-x_hold[.,2:numx])')./(maxc(-x_hold[.,2:numx])'-minc(-x_hold[.,2:numx])');
    x_both=x_plus~x_minus; numxboth=cols(x_both);
    endif;
    
    // Now do second order
    if add_interactions>=2;
    firstone=1;
    i1=1; do while i1<=numxboth;
    i2=i1; do while i2<=numxboth;
    if firstone==1;  x_both2=x_both[.,i1].*x_both[.,i2]; firstone=0;
    else; x_both2=x_both2~(x_both[.,i1].*x_both[.,i2]); endif;
    i2=i2+1; endo; i1=i1+1; endo;
    endif;
    
     // Now do third order
    if add_interactions>=3;
    firstone=1;
    i1=1; do while i1<=numxboth;
    i2=i1; do while i2<=numxboth;
    i3=i2; do while i3<=numxboth;
    if firstone==1;  x_both3=x_both[.,i1].*x_both[.,i2].*x_both[.,i3]; firstone=0;
    else; x_both3=x_both3~(x_both[.,i1].*x_both[.,i2].*x_both[.,i3]); endif;
    i3=i3+1; endo; i2=i2+1; endo; i1=i1+1; endo; 
    endif;
    
    // Now do fourth order
    if add_interactions>=4;
    firstone=1;
    i1=1; do while i1<=numxboth;
    i2=i1; do while i2<=numxboth;
    i3=i2; do while i3<=numxboth;
    i4=i3; do while i4<=numxboth;
    if firstone==1;  x_both4=x_both[.,i1].*x_both[.,i2].*x_both[.,i3].*x_both[.,i4]; firstone=0;
    else; x_both4=x_both4~(x_both[.,i1].*x_both[.,i2].*x_both[.,i3].*x_both[.,i4]); endif;
    i4=i4+1; endo; i3=i3+1; endo; i2=i2+1; endo; i1=i1+1; endo; 
    endif;
    
    // Now do fift order
    if add_interactions>=5;
    firstone=1;
    i1=1; do while i1<=numxboth;
    i2=i1; do while i2<=numxboth;
    i3=i2; do while i3<=numxboth;
    i4=i3; do while i4<=numxboth;
    i5=i4; do while i5<=numxboth;
    if firstone==1;  x_both5=x_both[.,i1].*x_both[.,i2].*x_both[.,i3].*x_both[.,i4].*x_both[.,i5]; firstone=0;
    else; x_both5=x_both5~(x_both[.,i1].*x_both[.,i2].*x_both[.,i3].*x_both[.,i4].*x_both[.,i5]);  endif;
    i5=i5+1;endo; i4=i4+1; endo; i3=i3+1; endo; i2=i2+1; endo; i1=i1+1; endo; 
    endif;
    
    if     add_interactions==0;   z_hold=weight_factor_hold;    
    elseif add_interactions==1;   z_hold=weight_factor_hold.*(ones(rows(x_hold),1)~x_both);
    elseif add_interactions==2;   z_hold=weight_factor_hold.*(ones(rows(x_hold),1)~x_both~x_both2);
    elseif add_interactions==3;   z_hold=weight_factor_hold.*(ones(rows(x_hold),1)~x_both~x_both2~x_both3);
    elseif add_interactions==4;   z_hold=weight_factor_hold.*(ones(rows(x_hold),1)~x_both~x_both2~x_both3~x_both4);
    elseif add_interactions==5;   z_hold=weight_factor_hold.*(ones(rows(x_hold),1)~x_both~x_both2~x_both3~x_both4~x_both5);
    endif;
retp(z_hold);
endp;

proc (1)=construct_xz_mean(x_hold,group_hold,z_hold);
local num_z, xz_mean, j, i, hold;
num_z=cols(z_hold); //Number of Instruments;
xz_mean=zeros(num_z*numgroup,cols(x_hold));
j=1; // Index for instruments;
do while j<=num_z;
    i=1; //Index for pertubation type;  
    do while i<=numgroup; 
        hold=sumc(selif(x_hold.*z_hold[.,j],group_hold.==i))./rows(x_hold);
        xz_mean[(j-1)*numgroup+i,.]=hold';
        i=i+1; 
    endo;
    j=j+1; 
endo;
retp(xz_mean);
endp;




    
// Procedure to solve linear programming; 
//cat_obj=1 for mimization and =2 for maximization;
//cat_out=0 when do not want to print results and =1 when want to print results. 

proc (1)=lpmt_est(a, b, cat_obj, cat_out);
    struct LP lp0; 
    struct LPcontrol c0;
    struct LPout out1; 

    //Initialize structure;
    lp0=createlp; 
    c0=createLPcontrol;

    //Set structure;
    c0.output=0;
    lp0.a = a; lp0.b = b; lp0.c = {1,0,0}; lp0.l = 0; lp0.u = 1e200; 
    c0.minimize = cat_obj;            

    //Choose the type of output; 
    if cat_out==0; out1= lpmt(lp0,c0);
    else;          out1= lpmtprt(lpmt(lp0,c0),c0);
    endif;

    retp(out1);
endp;


// New Procedure Procedure to solve linear programming; 
//cat_obj=1 for mimization and =2 for maximization;
//cat_out=0 when do not want to print results and =1 when want to print results. 

proc (6)=lpmt_tom(a, b, cat_out,use_starting_value);
local min_value, theta_lower, bind_constraint_min,lpmt_returncode, max_value,theta_upper,bind_constraint_max, 
f, g, retcode, vof_new;
    struct LP lp0; 
    struct LPcontrol c0;
    struct LPout out1; 

    //Initialize structure;
    lp0=createlp; 
    c0=createLPcontrol;

    //Set structure;
    c0.output=0;
    lp0.a = a; lp0.b = b; lp0.c = {1,0,0}; lp0.l = 0; lp0.u = 1e200; 
    c0.minimize = 1;     //first do minimum;
    if use_starting_value==1; c0.start=(theta_star|(b - a*theta_star)); endif;

    //Choose the type of output; 
    if cat_out==0; out1= lpmt(lp0,c0);
    else;          out1= lpmtprt(lpmt(lp0,c0),c0);
    endif;
    
    min_value=out1.optimumValue;
    theta_lower=out1.solution[1:3];
    bind_constraint_min=out1.state .ne 0;
    lpmt_returncode=out1.returncode;
    
    if lpmt_returncode==0; // this means feasible.
    vof_new=0;
    c0.minimize = 2;     // now do maximum;    
    //Choose the type of output; 
    if cat_out==0; out1= lpmt(lp0,c0);
    else;          out1= lpmtprt(lpmt(lp0,c0),c0);
    endif;
    max_value=out1.optimumValue;
    theta_upper=out1.solution[1:3];
    bind_constraint_max=out1.state .ne 0;
    else;
    // just get stuff from optmum.
    theta_lower=theta_star; theta_upper=theta_star;
    min_value=theta_star[1]; max_value=theta_star[1];
    vof_new=vof_optmum;
    endif;
    retp(min_value,theta_lower,lpmt_returncode,max_value,theta_upper,vof_new);
endp;


proc obj(theta_tran);
local vof, hold, theta;
theta=theta_tran.^2;
hold=b-a*theta;
hold=minc(zeros(1,rows(hold))|(hold'));
vof=sumc(hold.^2);
retp(vof);
endp;


output off;

